﻿using System;
using Infragistics.Web.UI.GridControls;
using System.Data;
public partial class Samples_WebDataGrid_Display_Summaries_Custom_Summary_Default : System.Web.UI.Page
{   
    protected object WebDataGrid1_CalculateCustomSummary(object sender, CustomSummaryEventArgs e)
    {    
        double sum = 0.0;   
        int n = 0;     
        foreach (GridRecord gr in this.WebDataGrid1.Rows)
        {            
            sum += Convert.ToDouble(gr.Items[2].Value); 
            ++n;        
        }  
        //calculate the sum of squared deviations
        double mean = sum / n;
        sum = 0;
        foreach (GridRecord gr in this.WebDataGrid1.Rows)  
        {          
            sum += Math.Pow(mean - Convert.ToDouble(gr.Items[2].Value), 2); 
        }  
        sum = sum / (n - 1);
        return Math.Round(Math.Sqrt(sum), 2); 
    }   
    protected void Page_Load(object sender, EventArgs e)
    {
                    WebDataGrid1.DataSource = MakeTable();
           
        if (!IsPostBack)
        {

            AddRemoveCustomSummary(true);
        }        
    }   
    protected void chkCustomSummaries_CheckedChanged(object sender, EventArgs e)
    {
       
        if (chkCustomSummaries.Checked)
        {
            AddRemoveCustomSummary(chkCustomSummaries.Checked);  
        }
       
    }    
    protected void AddRemoveCustomSummary(bool isAdd) 
    {      
        SummaryRow summaryRowBehavior = this.WebDataGrid1.Behaviors.SummaryRow;  
        //returns the index where the st.dev summary option appears in the drop down   
        int summarySettingIndex = -1; 
        if (summaryRowBehavior.ColumnSettings["UnitPrice"] != null)   
        {         
            foreach (SummarySetting summarySetting in summaryRowBehavior.ColumnSettings["UnitPrice"].SummarySettings) 
            {      
                if (summarySetting.CustomSummaryName == "STDEV") 
                {               
                    summarySettingIndex = summaryRowBehavior.ColumnSettings["UnitPrice"].SummarySettings.IndexOf(summarySetting); 
                    break;   
                }          
            }     
        }     
        //returns the index where the summary definition for the st.dev summary appears in the column  
        int summaryIndex = -1;   
        if (summaryRowBehavior.ColumnSummaries["UnitPrice"] != null) 
        {        
            foreach (Summary summary in summaryRowBehavior.ColumnSummaries["UnitPrice"].Summaries) 
            {               
                if (summary.CustomSummaryName == "STDEV")   
                {              
                    summaryIndex = summaryRowBehavior.ColumnSummaries["UnitPrice"].Summaries.IndexOf(summary);
                    break;  
                }          
            }      
        }        
        if (isAdd)  
        {  
            //setup settings menu 
            SummaryRowSetting summaryRowSetting = new SummaryRowSetting(this.WebDataGrid1, "UnitPrice");
            SummarySetting customSummarySetting = new SummarySetting();
            customSummarySetting.SummaryType = SummaryType.Custom;  
            customSummarySetting.CustomSummaryName = "STDEV";     
            customSummarySetting.FormatString = "STDEV = {1}";  
            summaryRowSetting.SummarySettings.Add(customSummarySetting); 
            //setup summary logic    
            ColumnSummaryInfo customColumnSummaryInfo = new ColumnSummaryInfo();  
            customColumnSummaryInfo.ColumnKey = "UnitPrice"; 
            Summary customSummary = new Summary();     
            customSummary.SummaryType = SummaryType.Custom;     
            customSummary.CustomSummaryName = "STDEV";      
            customColumnSummaryInfo.Summaries.Add(customSummary);    
            //adding a column summary for UnitPrice column if not already added  
            if (summaryRowBehavior.ColumnSummaries["UnitPrice"] == null)  
                summaryRowBehavior.ColumnSummaries.Add(customColumnSummaryInfo);   
            else       
            {         
                //add a summary 
                if (summaryIndex == -1)  
                    summaryRowBehavior.ColumnSummaries["UnitPrice"].Summaries.Add(customSummary);
            }           
            //adding a column summaryRowSetting for the column if not already added
            //---uncommenting the following code will provide existing button for sum
            //if (summaryRowBehavior.ColumnSettings["UnitPrice"] == null)
            //    summaryRowBehavior.ColumnSettings.Add(summaryRowSetting);
            //else
            //{
            //    //add a summary summaryRowSetting for the column   
            //    if (summarySettingIndex == -1)
            //        summaryRowBehavior.ColumnSettings["UnitPrice"].SummarySettings.Add(customSummarySetting);
            //}      
        }      
        else     
        {    
            //if summary settings have been added, remove them  
            if (summaryRowBehavior.ColumnSettings["UnitPrice"] != null && summarySettingIndex != -1) 
                summaryRowBehavior.ColumnSettings["UnitPrice"].SummarySettings.RemoveAt(summarySettingIndex); 
            //if a summary definition has been added, remove them 
            if (summaryRowBehavior.ColumnSummaries["UnitPrice"] != null && summaryIndex != -1) 
                summaryRowBehavior.ColumnSummaries["UnitPrice"].Summaries.RemoveAt(summaryIndex); 
        }

       
    }

    private DataTable MakeTable()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "ProductID";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "ProductName";
        column.AutoIncrement = false;
        column.Caption = "ProductName";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);

        // Create third column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Double");
        column.ColumnName = "UnitPrice";
        column.AutoIncrement = false;
        column.Caption = "UnitPrice";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);

        // Create forth column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "UnitsInStock";
        column.AutoIncrement = false;
        column.Caption = "UnitsInStock";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);

        // Create fifth column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "UnitsOnOrder";
        column.AutoIncrement = false;
        column.Caption = "UnitsOnOrder";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);

        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["ProductID"] = i;
            row["ProductName"] = "Item " + i;
            row["UnitPrice"] = 0.33 + i*5;
            row["UnitsInStock"] = i * 10;
            row["UnitsOnOrder"] = i * 2;
            table.Rows.Add(row);
        }
        return table;

    }


}